MODULE time_mod

  PRIVATE

  INTEGER,SAVE :: ncid
  INTEGER,SAVE :: time_counter_id
  INTEGER,SAVE :: it

  PUBLIC create_time_counter_header, update_time_counter, close_time_counter



CONTAINS

  SUBROUTINE create_time_counter_header
  USE netcdf_mod
  USE prec
  USE ioipsl
  IMPLICIT NONE
  INTEGER :: status
  INTEGER :: timeid, dtid
  REAL(rstd) :: dt
    status = NF90_CREATE('time_counter.nc', NF90_CLOBBER, ncid)
    status = NF90_DEF_DIM(ncid,'time_counter',NF90_UNLIMITED,timeid)
    status = NF90_DEF_VAR(ncid,'time_counter',NF90_DOUBLE,(/ timeid /),time_counter_id)
    status = NF90_PUT_ATT(ncid,time_counter_id,"long_name","time")
    status = NF90_PUT_ATT(ncid,time_counter_id,"units","seconds since 2000-01-01 00:00:00")
    status = NF90_PUT_ATT(ncid,time_counter_id,"calendar","noleap")
    status = NF90_DEF_VAR(ncid,'mdt',NF90_DOUBLE,varid=dtid)
    status = NF90_ENDDEF(ncid) 

    CALL getin("dt",dt)
    status=NF90_PUT_VAR(ncid,dtid, dt)
    it=0

  END SUBROUTINE create_time_counter_header
  
  SUBROUTINE update_time_counter(time)
  USE netcdf_mod
  USE prec
  IMPLICIT NONE
  REAL(rstd),INTENT(IN) ::time
  INTEGER :: status
  REAL(rstd) ::time_array(1)
    time_array(1)=time
  
    it=it+1
    status=NF90_PUT_VAR(ncid,time_counter_id,time_array,start=(/ it /),count=(/ 1 /))
    status=NF90_SYNC(ncid)
  END SUBROUTINE update_time_counter    
  
  SUBROUTINE close_time_counter
  USE netcdf_mod
  IMPLICIT NONE
    INTEGER :: status
    
    status=NF90_CLOSE(ncid)
    
  END SUBROUTINE  close_time_counter 

END MODULE time_mod
